from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.post_knowledges_id_documents_body_data import PostKnowledgesIdDocumentsBodyData


T = TypeVar("T", bound="PostKnowledgesIdDocumentsBody")


@_attrs_define
class PostKnowledgesIdDocumentsBody:
    """
    Attributes:
        content (str):  Example: Document content goes here....
        data (Union[Unset, PostKnowledgesIdDocumentsBodyData]):  Example: {'title': 'Document Title', 'category':
            'tutorial'}.
    """

    content: str
    data: Union[Unset, "PostKnowledgesIdDocumentsBodyData"] = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        content = self.content

        data: Union[Unset, dict[str, Any]] = UNSET
        if not isinstance(self.data, Unset):
            data = self.data.to_dict()

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "content": content,
            }
        )
        if data is not UNSET:
            field_dict["data"] = data

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.post_knowledges_id_documents_body_data import PostKnowledgesIdDocumentsBodyData

        d = dict(src_dict)
        content = d.pop("content")

        _data = d.pop("data", UNSET)
        data: Union[Unset, PostKnowledgesIdDocumentsBodyData]
        if isinstance(_data, Unset):
            data = UNSET
        else:
            data = PostKnowledgesIdDocumentsBodyData.from_dict(_data)

        post_knowledges_id_documents_body = cls(
            content=content,
            data=data,
        )

        post_knowledges_id_documents_body.additional_properties = d
        return post_knowledges_id_documents_body

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
